# Copyright (C) 2006-2012 Oracle. All rights reserved.
#
# This program is free software; you can redistribute it and/or modify it under
# the terms of the GNU General Public License as published by the Free Software
# Foundation, version 2.  This program is distributed in the hope that it will
# be useful, but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General
# Public License for more details.  You should have received a copy of the GNU
# General Public License along with this program; if not, write to the Free
# Software Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA
# 021110-1307, USA.

import logging
import time
from agent.api.base import Agent
from agent.lib.settings import get_api_version
from agent.utils.xmlrpclib import ServerProxy


class Common(Agent):
    """
    Common functions.
    """

    def get_services(self, version=None):
        return {
            'echo': echo,
            'sleep': sleep,
            'dispatch': dispatch,
            'get_api_version': get_api_version}


def echo(msg):
    return msg


def sleep(secs):
    time.sleep(float(secs))


def dispatch(uri, func, *args):
    try:
        logging.debug("dispatch function %s to server %s" % (func, uri))
        sp = ServerProxy(uri)
        return getattr(sp, func)(*args)
    except Exception, e:
        logging.error("dispatch error: %s: %s" % (func, e))
        raise
