#!/usr/bin/env python
#
# Copyright (C) 2011-2012 Oracle. All rights reserved.
#
# This program is free software; you can redistribute it and/or modify it under
# the terms of the GNU General Public License as published by the Free Software
# Foundation, version 2.  This program is distributed in the hope that it will
# be useful, but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General
# Public License for more details.  You should have received a copy of the GNU
# General Public License along with this program; if not, write to the Free
# Software Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA
# 021110-1307, USA.
####################################################################################################
#
#	Author:		Joshua Nicholas
#
"""Utilities for helping with deal with time
"""

import datetime
import time

####################################################################################################

__all__ = [	'VI_DATETIME_ZERO'
		,	'VI_DATETIME_HOUR'
		,	'VI_UTC'
		,	'vi_calc_delta_time'
		,	'vi_delta_time_to_now' ]

####################################################################################################

VI_DATETIME_ZERO	= datetime.timedelta( 0 )
VI_DATETIME_HOUR	= datetime.timedelta( hours=1 )

class VI_UTC(datetime.tzinfo):		# Why Oh WHY is this not included for free ???
    """UTC"""

    def utcoffset( self, dt ):
        return VI_DATETIME_ZERO

    def tzname( self, dt ):
        return "UTC"

    def dst( self, dt ):
        return VI_DATETIME_HOUR

####################################################################################################
def vi_calc_delta_time( begTimeInSecs, endTimeInSecs ):
	"""
	This routine
	"""
#
	if endTimeInSecs >= begTimeInSecs:
		return endTimeInSecs - begTimeInSecs
	return     begTimeInSecs - endTimeInSecs

####################################################################################################
def vi_delta_time_to_now( begTimeInSecs ):
	"""
	This routine
	"""
#
	return vi_calc_delta_time( begTimeInSecs, time.time() )

####################################################################################################
# END
